-- FALKLANDS FOOTHOLD DANICA DYNAMIC WAR (Made by Obi of Danica, based on the "Foothold concept" missions with the ZoneCommander framework made by Dzsek)
-- Bingo for Hornet from PuntaArenas @FL35, 100% Winchester & optimum cruising = 6.500 lbs
-- Bingo for Viper fra PuntaArenas @FL35, 100% Winchester & optimum cruising = 4.000 lbs
--------------------------------------------------------------------------------------
-- SupplyZones : MountPleasant, Carrier, PortStanley, SanCarlosFOB, GooseGreen, PortHoward, FoxBayAirfield, BleakerFarm, RioGrande, PuntaArenas, RioGallegos, SanJulian}
---------------------------------------------------------------------------------------
-- Obi To-Do's: SouthAtlantic_Foothold v. 0.6.x
--1--	PARTIAL Build Red CAP Patrols on major airbases on the Mainland
--2--	Add a few attack ships on the mainland?
--3--	Set all aircraft to Radio 305 as minimum
--4--	Check Shop-Harriers waypoint routes, cruising around for too loong in Winchester
--5--	Change Hornets and Vipers on MtPleasant to A-A Loadout as default.
--6--	Helikoptere skal måske ikke være ACE niveau.
--7--	
--8--	
--9--	
--10-	
--11-	
--12-
--13-
--14-
--15-	

-- Run functions to create object tables for the mission environment to run
function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

-- Define how many upgrade levels (1-?), and what equipment is part of the upgrade level - for every zonetype you plan to use.
-- Defined Blue groups usable in this mission file is: 
-- bAPC, bInfantry, bArmor, bSamIR, bSam1, bSam2, bSam3
-- Defined Red groups usable in this mission file is: 
-- New SAM list = redEWR, redSamIR, redSA15, redSA3, redSA2, redSA5, redSA6, redHQ7, redSA10, redSA11, redSA19, 
-- Other Ground = redAPC, redInfantry, redArmor, redmlrs
--
CarrierUpgrades = {
	blue = {"bSub", "bFrigate-1", "bFrigate-2", "bFrigate-3", "bDestroyer"},
	red = {"RedCarrier", "RedSubmarine", "RedFrigateA", "RedCargoship1", "RedDestroyerB", "RedSupportship"}
}

Ships = {
	blue = {},
	red = {"RedCargo1", "RedCargo2"}
}

airfield = {
	blue = {"bAPC", "bArmor", "bSamIR", "bRoland", "bNASAMS"},
	red = {"redInfantry", "redArmor", "redSamIR", "redSA15", "redSA3", "redSA11"}
}

airbase = {
	blue = {"bAPC", "bArmor", "bRoland", "bArmor", "bArty", "bNASAMS", "bHawk", "bMLRS"},
	red = {"redInfantry", "redSamIR", "redSA2", "redSA15", "redArmor", "redSA3", "redArmor", "redSA15"}
}

farp = {
	blue = {"bAPC", "bArmor", "bSamIR", "bRoland"},
	red = {"redInfantry", "redAPC", "redArmor", "redSamIR", "redSA8"}
}

fob = {
	blue = {"bAPC", "bArmor", "bRoland", "bArty", "bNASAMS"},
	red = {"redInfantry", "redArmor", "redSamIR", "redHQ7", "redSA6"}
}

regularzone = {
	blue = {"bAPC", "bArmor", "bSamIR", "bRoland"},
	red = {"redInfantry", "redArmor", "redSamIR", "redHQ7"}
}

islandSAM = {
	blue = {"bAPC", "bSamIR", "bRoland", "bNASAMS"},
	red = {"redInfantry", "redSamIR", "redHQ7", "redSA15"}
}

specialSAM = {
	blue = {"bAPC", "bRoland", "bRoland", "bNASAMS", "bHawk"},
	red = {"redInfantry", "redArmor", "redSA15", "redSA10", "redSA3", "redSA15"}
}

strategicSAM = {
	blue = {"bAPC", "bRoland", "bRoland", "bNASAMS", "bHawk"},
	red = {"redArmor", "redSA15", "redSA5", "redSA3", "redSA15"}
}

convoy = {
	blue = {"bAPC"},
	red = {"redAPC", "redAPC", "redAPC"}
}

cargoSpawns = {
	["MountPleasant"] = {"c1","c2","c3"},
	["PortStanley"] = {"c4","c5","c6"},
	["SanCarlosFOB"] = {"c7","c8","c9"},
	["GooseGreen"] = {"c10","c11","c12"},
	["PortHoward"] = {"c13","c14","c15"},
	["FoxBayAirfield"] = {"c16","c17","c18"},
	["BleakerFarm"] = {"c19","c20","c21"},
	["RioGrande"] = {"c22","c23","c24"},
	["PuntaArenas"] = {"c25","c26","c27"},
	["RioGallegos"] = {"c28","c29","c30"},
	["AeropuertodeGobernadorGregores"] = {"c31","c32","c33"},
	["SanJulian"] = {"c34","c35","c36"}
}

cargoAccepts = {
	MountPleasant =  allExcept(cargoSpawns, 'MountPleasant'),
	Carrier =  allExcept(cargoSpawns, 'Carrier'),
	GooseGreen =  allExcept(cargoSpawns, 'GooseGreen'),
	PortStanley =  allExcept(cargoSpawns, 'PortStanley'),
	general = allExcept(cargoSpawns)
}

-- Set flavor text for your mission waypoints/zones
flavor = {
	MountPleasant = 'WPT 1\nThe purpose build RAF Airbase in Western Falklands.',
	Carrier = 'WPT 2\nUSN & UK Carrier strike force.',
	PortStanley = 'WPT 3\nCapital of the Falkland island and the second largest airfield.',
	LorenzoFARP = 'WPT 4\nA small Forward Arming & Refuelling Point (FARP) in the northern part of East Falklands.',
	CapeDolphin = 'WPT 5\nThis small cape is the northmost point on West Falklands, named after HMS Dolphin the ship of the British explorer John Byron.',
	SanCarlosFOB = 'WPT 6\nA FOB in the San Carlos settlement. Named after a visiting ship in 1768 and used as the main British Army beachhead in the Falklands War.',
	GooseGreen = 'WPT 7\nSmall airfield and settlement, site of the Battle of Goose Green between the British Army and Argentine forces in the Falklands War. Currently home to a SuperDARN antenna array station.',
	PebbleIsland = 'WPT 8\nPebble Island is the 5th largest island in the Falklands and site of a small Forward Operating Base (FOB) to rearm and refuel helicopters and V/STOL aircraft.',
	NorthWestPointFARP = 'WPT 9\nOriginally known as Albatros Island, this is known to have some spectacular scenery - and lots of albatrosses.',
	PortHoward = 'WPT 10\nThe largest settlement in the West Falklands on an inlet of Falkland Sound. It has 2 small airfields and a Ferry connection to East Falklands.',
	ShallopPoint = 'WPT 11\nShallop Point in the middle of West Falklands near the mouth of the river Chartres, is an important strategic location as well as an excellent place to go fly fishing.',
	FoxBayAirfield = 'WPT 12\nFox Bay consists of two settlements (East & West), a harbour and an airfield used by RAF to refuel their helicopters.',
	WeddelFarmFARP = 'WPT 13\nWeddel Island in the south-west is the third largest island in the Falklands and the largest privately owned island in the world. Host to a small airstrip and refuelling service.',
	PortStephens = 'WPT 14\nA settlement and harbour in the south of the West Falklands. Used to be the largest sheep station in Falklands but has since been divided into smaller farms.',
	AlbemarieStation = 'WPT 15\nWith a near perfect natural harbour, this used to be a very successfull Sealing station in the 19th century. It is now all but abandoned allthough there is still a sheep station there.',
	NorthArmFarm = 'WPT 16\nNorth Arm is a settlement in Lafonia, the south part of East Falklands. This is the largest settlement south of Goose Green with a harbour and small airfield.',
	BleakerFarm = 'WPT 17\nBleaker Farm located on Bleaker island along with the airfield of Gull Point as well as Bleaker Farms own grass strips.',
	SeaLionIsland = 'WPT 18\nSea Lion Island is the southernmost inhabited island of the Falkland Islands. Home to an airstrip, some accomodations and a memorial to the HMS Sheffield.',
	RioGrande = 'WPT 19\nRío Grande is a city in Argentina, on the north coast of the eastern part of the Isla Grande de Tierra del Fuego. Home of the Hermes Quijada International Airport.',
	Castillo = 'WPT 20\nCastillo is an Argentinian tactical SA-10 site, protecting the southernmost region of Argentina. The SAM site has 3 critical targets you can exploit: The Command Center bunker, the Ammo Depot bunker and the Comms Tower. Destroy these to prevent the sites being reinforced.',
	Ushuaia = 'WPT21\nThis is the worlds southernmost international airport and is often used by passengers as a cruise-ship gateway to the Antarctic. It can accomodate aircraft as big as a Boeing 747, after the new airport opened in 1995.',
	PuertoWilliams = 'WPT22\nPuerto Williams is the city, port and naval base on Navarino Island in Chile, and is also the southernmost manned settlement in the world.',
	AerodromoDeTolhuin = 'WPT23\nAeropuerto de Tolhuin Lago Fagnano, is a public use airport located 2 kilometres (1 mi) northeast of Tolhuin, a lakeside village in the Tierra del Fuego Province of Argentina.',
	PampaGuanaco = 'WPT24\nAeropuerto Pampa Guanaco, is a rural airport near Inútil Bay, serving Camerón in the Timaukel commune, part of the Tierra del Fuego province in the Magallanes Region of Chile.',
	AlmiranteSchroeders = 'WPT25\nAeropuerto de Almirante Schroeders, is a military airport on the northern point of Isla Dawson, an island midway through the Strait of Magellan in the Magallanes y Antártica Chilena Region of Chile.',
	PorvenirAirfield = 'WPT26\nAeródromo Capitán Fuentes Martínez, is an airport 3.1 nm northeast of Porvenir, a port city off the Strait of Magellan in the Magallanes Region of Chile. East approach and departure are partially over the water.',
	PuntaArenas = 'WPT 27\nPunta Arenas is the capital of Chile’s southernmost region. Home to flights to the Antarctica as well as an important base for the Chilean Air Force.',
	FrancoBianco = 'WPT28\nFranco Bianco Airport is located 3 nm northwest of Cerro Sombrero, a petroleum production town in the Magallanes Region of Chile. Cerro Sombrero is near the eastern entrance to the Strait of Magellan.',
	RioGallegos = 'WPT 29\nRío Gallegos is the capital and largest settlement of the Patagonian province of Santa Cruz in Argentina. With an Intl. airport and an important stop for flights between Chile and the Falkland Islands.',
	RioChico = 'WPT30\Rio Chico is Spanish for small river, and is the name of a part of Rio Gallegos, and a small civilian airport in southern part of the city of Rio Gallegos.',
	Esperanza = 'WPT31\nEsperanza is an Argentinian strategic SA-5 site, protecting parts of the Patagonia region of Argentina. The SAM site has 3 critical targets you can exploit: The Command Center bunker, the Ammo Depot bunker and the Comms Tower. Destroy these to prevent the sites being reinforced.',
	RioTurbio = 'WPT32\nRío Turbio Airport is an airport serving Río Turbio, a town in the Santa Cruz Province of Argentina. The airport is just south of 28 de Noviembre, a town 10 kilometres (6 mi) southeast of Rio Turbio. The international border with Chile is just 3.7 nm west of the airport.',
	PuertoNatales = 'WPT33\nAeródromo Teniente Julio Gallardo near Puerto Natales, a city in the Magallanes Region of Chile. The airport is 4.3 nm north-northwest of Puerto Natales, which is on the Admiral Montt Gulf (es), a long fjord that reaches inland close to the border with Argentina. The airport is 7.5 nm from the border.',
	ElCalafate = 'WPT34\nAeropuerto Internacional de El Calafate is an airport in Santa Cruz Province, Argentina. It is located 13 nm east of the city of El Calafate. It is the westernmost Argentinian airport served by scheduled flights. In 2010, the airport was used by over 500,000 passengers.',
	AerodromoOHiggins = 'WPT35\nGeneral Bernardo OHiggins Airport is an airport serving Chillán, a city in the Diguillín Province of Chiles Ñuble Region. The airport is 3.7 nm northeast of the city. The airport is named for Bernardo OHiggins, the first Chilean head of state.',
	AeropuertodeGobernadorGregores = 'WPT36\nGobernador Gregores Airport, is an airport serving Gobernador Gregores, a town in the Santa Cruz Province of Argentina. The airport is 4 nm east-southeast of the town, on a low mesa above the Chico River.',
	PuertoSantaCruz = 'WPT37\nSanta Cruz Airport, is an airport serving Puerto Santa Cruz, a town on the Santa Cruz River estuary in the Santa Cruz Province of Argentina. The airport is 2 nm inland from the town.',
	ComandanteLuisPiedrabuena = 'WPT38\nA small airport just west of Santa Cruz Airport, a typical small airport where you can take flying lessons or go skydiving and parachute jumping.',
	LagunaGrande = 'WPT39\nLaguna Grande is an Argentinian strategic SA-5 site, protecting parts of the Patagonia region of Argentina. The SAM site has 3 critical targets you can exploit: The Command Center bunker, the Ammo Depot bunker and the Comms Tower. Destroy these to prevent the sites being reinforced.',
	SanJulian = 'WPT 40\nPuerto San Julián is the closest point on the mainland to the Falkland Islands. As such it was an important airbase for the Argentinian Air Force in the Falklands War.',
	RedNavalZone = 'WPT 41\nThis entire zone has been restricted by Chinese/Argentinian forces due to live-fire naval excercises.',
	}


-- Setup the file path for pesistent status saving
local filepath = 'falklands_foothold_save.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end
bc = BattleCommander:new(filepath, 10, 60)


-- Define all your zones on the map, which side they start as, upgrade level and more. These can be capturable or give a specific benefit or bonus.
-- Side 0 = Neutral, Side 1 = Red and Side 2 = Blue
-- The income parameter is amount of credits per tick, a tick is 10 seconds. Ie. 1 = 360 credits per hour, 2 = 720, 3 = 1080, 4 = 1440 and 5 = 1800.

MountPleasant = ZoneCommander:new({zone='MountPleasant', side=2, level=4, upgrades=airbase, crates=cargoAccepts.MountPleasant, flavorText=flavor.MountPleasant, income=1})
Carrier = ZoneCommander:new({zone='Carrier', side=2, level=1, upgrades=CarrierUpgrades, crates=cargoAccepts.Carrier, flavorText=flavor.Carrier})
PortStanley = ZoneCommander:new({zone='PortStanley', side=1, level=5, upgrades=airfield, crates=cargoAccepts.PortStanley, flavorText=flavor.PortStanley, income=1})
LorenzoFARP = ZoneCommander:new({zone='LorenzoFARP', side=1, level=2, upgrades=farp, crates=cargoAccepts.LorenzoFARP, flavorText=flavor.LorenzoFARP})
CapeDolphin = ZoneCommander:new({zone='CapeDolphin', side=0, level=2, upgrades=regularzone, crates=cargoAccepts.CapeDolphin, flavorText=flavor.CapeDolphin})
SanCarlosFOB = ZoneCommander:new({zone='SanCarlosFOB', side=1, level=2, upgrades=airfield, crates=cargoAccepts.SanCarlosFOB, flavorText=flavor.SanCarlosFOB, income=1})
GooseGreen = ZoneCommander:new({zone='GooseGreen', side=1, level=2, upgrades=farp, crates=cargoAccepts.GooseGreen, flavorText=flavor.GooseGreen, income=1})
PebbleIsland = ZoneCommander:new({zone='PebbleIsland', side=1, level=2, upgrades=regularzone, crates=cargoAccepts.PebbleIsland, flavorText=flavor.PebbleIsland})
NorthWestPointFARP = ZoneCommander:new({zone='NorthWestPointFARP', side=1, level=2, upgrades=farp, crates=cargoAccepts.NorthWestPointFARP, flavorText=flavor.NorthWestPointFARP})
PortHoward = ZoneCommander:new({zone='PortHoward', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.PortHoward, flavorText=flavor.PortHoward})
ShallopPoint = ZoneCommander:new({zone='ShallopPoint', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.ShallopPoint, flavorText=flavor.ShallopPoint})
FoxBayAirfield = ZoneCommander:new({zone='FoxBayAirfield', side=1, level=1, upgrades=airfield, crates=cargoAccepts.FoxBayAirfield, flavorText=flavor.FoxBayAirfield, income=1})
WeddelFarmFARP = ZoneCommander:new({zone='WeddelFarmFARP', side=1, level=1, upgrades=farp, crates=cargoAccepts.WeddelFarmFARP, flavorText=flavor.WeddelFarmFARP})
PortStephens = ZoneCommander:new({zone='PortStephens', side=1, level=0, upgrades=regularzone, crates=cargoAccepts.PortStephens, flavorText=flavor.PortStephens})
AlbemarieStation = ZoneCommander:new({zone='AlbemarieStation', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.AlbemarieStation, flavorText=flavor.AlbemarieStation})
NorthArmFarm = ZoneCommander:new({zone='NorthArmFarm', side=1, level=1, upgrades=regularzone, crates=cargoAccepts.NorthArmFarm, flavorText=flavor.NorthArmFarm})
BleakerFarm = ZoneCommander:new({zone='BleakerFarm', side=1, level=2, upgrades=farp, crates=cargoAccepts.BleakerFarm, flavorText=flavor.BleakerFarm, income=1})
SeaLionIsland = ZoneCommander:new({zone='SeaLionIsland', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.SeaLionIsland, flavorText=flavor.SeaLionIsland, income=1})
RioGrande = ZoneCommander:new({zone='RioGrande', side=1, level=3, upgrades=airbase, crates=cargoAccepts.RioGrande, flavorText=flavor.RioGrande, income=1})
Castillo = ZoneCommander:new({zone='Castillo', side=1, level=3, upgrades=specialSAM, crates=cargoAccepts.Castillo, flavorText=flavor.Castillo})
Ushuaia = ZoneCommander:new({zone='Ushuaia', side=1, level=1, upgrades=airfield, crates=cargoAccepts.Ushuaia, flavorText=flavor.Ushuaia, income=1})
PuertoWilliams = ZoneCommander:new({zone='PuertoWilliams', side=0, level=1, upgrades=airfield, crates=cargoAccepts.PuertoWilliams, flavorText=flavor.PuertoWilliams})
AerodromoDeTolhuin = ZoneCommander:new({zone='AerodromoDeTolhuin', side=1, level=1, upgrades=airfield, crates=cargoAccepts.AerodromoDeTolhuin, flavorText=flavor.AerodromoDeTolhuin})
PampaGuanaco = ZoneCommander:new({zone='PampaGuanaco', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.PampaGuanaco, flavorText=flavor.PampaGuanaco})
AlmiranteSchroeders = ZoneCommander:new({zone='AlmiranteSchroeders', side=0, level=1, upgrades=airfield, crates=cargoAccepts.AlmiranteSchroeders, flavorText=flavor.AlmiranteSchroeders, income=1})
PorvenirAirfield = ZoneCommander:new({zone='PorvenirAirfield', side=0, level=1, upgrades=airfield, crates=cargoAccepts.PorvenirAirfield, flavorText=flavor.PorvenirAirfield})
PuntaArenas = ZoneCommander:new({zone='PuntaArenas', side=0, level=2, upgrades=airbase, crates=cargoAccepts.PuntaArenas, flavorText=flavor.PuntaArenas, income=1})
FrancoBianco = ZoneCommander:new({zone='FrancoBianco', side=0, level=1, upgrades=airfield, crates=cargoAccepts.FrancoBianco, flavorText=flavor.FrancoBianco})
RioGallegos = ZoneCommander:new({zone='RioGallegos', side=1, level=3, upgrades=airbase, crates=cargoAccepts.RioGallegos, flavorText=flavor.RioGallegos, income=1})
Esperanza = ZoneCommander:new({zone='Esperanza', side=1, level=3, upgrades=strategicSAM, crates=cargoAccepts.Esperanza, flavorText=flavor.Esperanza})
RioChico = ZoneCommander:new({zone='RioChico', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.RioChico, flavorText=flavor.RioChico})
RioTurbio = ZoneCommander:new({zone='RioTurbio', side=1, level=1, upgrades=airfield, crates=cargoAccepts.RioTurbio, flavorText=flavor.RioTurbio})
PuertoNatales = ZoneCommander:new({zone='PuertoNatales', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.PuertoNatales, flavorText=flavor.PuertoNatales, income=1})
ElCalafate = ZoneCommander:new({zone='ElCalafate', side=1, level=1, upgrades=airfield, crates=cargoAccepts.ElCalafate, flavorText=flavor.ElCalafate})
AerodromoOHiggins = ZoneCommander:new({zone='AerodromoOHiggins', side=0, level=1, upgrades=regularzone, crates=cargoAccepts.AerodromoOHiggins, flavorText=flavor.AerodromoOHiggins, income=1})
AeropuertodeGobernadorGregores = ZoneCommander:new({zone='AeropuertodeGobernadorGregores', side=1, level=1, upgrades=airfield, crates=cargoAccepts.AeropuertodeGobernadorGregores, flavorText=flavor.AeropuertodeGobernadorGregores})
PuertoSantaCruz = ZoneCommander:new({zone='PuertoSantaCruz', side=1, level=1, upgrades=airfield, crates=cargoAccepts.PuertoSantaCruz, flavorText=flavor.PuertoSantaCruz})
ComandanteLuisPiedrabuena = ZoneCommander:new({zone='ComandanteLuisPiedrabuena', side=1, level=1, upgrades=regularzone, crates=cargoAccepts.ComandanteLuisPiedrabuena, flavorText=flavor.ComandanteLuisPiedrabuena})
LagunaGrande = ZoneCommander:new({zone='LagunaGrande', side=1, level=3, upgrades=strategicSAM, crates=cargoAccepts.LagunaGrande, flavorText=flavor.LagunaGrande})
SanJulian = ZoneCommander:new({zone='SanJulian', side=1, level=3, upgrades=airbase, crates=cargoAccepts.SanJulian, flavorText=flavor.SanJulian, income=1})
RedNavalZone = ZoneCommander:new({zone='RedNavalZone', side=1, level=6, upgrades=CarrierUpgrades, crates=cargoAccepts.RedNavalZone, flavorText=flavor.RedNavalZone, income=1})


-- Add defined Groups in Mission Editor to your Zones in ZoneCommander
-----------------------------------------------------------------------------------------------------------------------
---- We begin with the Falklands Zone Dispatch configurations
-----------------------------------------------------------------------------------------------------------------------	

dispatch = {
	MountPleasant={
		GroupCommander:new({name='MountPleasant-bsupply-1', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='MountPleasant-bsupply-2', mission='supply', targetzone='Carrier'}), --
		GroupCommander:new({name='MountPleasant-bsupply-3', mission='supply', targetzone='PortStanley'}), --
		GroupCommander:new({name='MountPleasant-bsupply-4', mission='supply', targetzone='PuntaArenas'}), --
		GroupCommander:new({name='MountPleasant-bsupply-5', mission='supply', targetzone='RioGrande'}) --
	},
	Carrier={
		GroupCommander:new({name='Carrier-bsupply-1', mission='supply', targetzone='MountPleasant', type='carrier_air'}), --
		GroupCommander:new({name='Carrier-bsupply-2', mission='supply', targetzone='PortStanley', type='carrier_air'}) --
	},	
	PortStanley = {
		GroupCommander:new({name='PortStanley-bsupply-1', mission='supply', targetzone='MountPleasant'}), --
		GroupCommander:new({name='PortStanley-bsupply-2', mission='supply', targetzone='SanJulian'}), --
		GroupCommander:new({name='PortStanley-bsupply-3', mission='supply', targetzone='RioGallegos'}), --
		GroupCommander:new({name='PortStanley-rsupply-1', mission='supply', targetzone='LorenzoFARP'}), --
		GroupCommander:new({name='PortStanley-rsupply-2', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='PortStanley-rsupply-3', mission='supply', targetzone='SanJulian'}), --
		GroupCommander:new({name='PortStanley-rpatrol-ac-1', mission='patrol', targetzone='PortStanley'}),
		GroupCommander:new({name='PortStanley-rattack-ship-1', mission='attack', targetzone='MountPleasant', type='surface'}),
		GroupCommander:new({name='PortStanley-rattack-ship-2', mission='attack', targetzone='MountPleasant', type='surface'}),
		GroupCommander:new({name='PortStanley-rattack-ship-3', mission='attack', targetzone='MountPleasant', type='surface'}),
		GroupCommander:new({name='PortStanley-rattack-ac-1', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='PortStanley-rattack-ac-2', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='PortStanley-rattack-ac-3', mission='attack', targetzone='Carrier'}),
		GroupCommander:new({name='PortStanley-rattack-hc-1', mission='attack', targetzone='MountPleasant'})
--		GroupCommander:new({name='PortStanley-rattack-vh-1', mission='attack', targetzone='MountPleasant', type='surface'}),
--		GroupCommander:new({name='PortStanley-rattack-vh-2', mission='attack', targetzone='LorenzoFARP', type='surface'})
	},
	LorenzoFARP = {
		GroupCommander:new({name='LorenzoFARP-rattack-hc-1', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='LorenzoFARP-rattack-hc-2', mission='attack', targetzone='PortStanley'})
	},
	SanCarlosFOB = {
		GroupCommander:new({name='SanCarlosFOB-bsupply-hc-1', mission='supply', targetzone='CapeDolphin'}), --
		GroupCommander:new({name='SanCarlosFOB-bsupply-hc-2', mission='supply', targetzone='LorenzoFARP'}), --
		GroupCommander:new({name='SanCarlosFOB-bsupply-hc-3', mission='supply', targetzone='MountPleasant'}), --
		GroupCommander:new({name='SanCarlosFOB-bsupply-hc-4', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='SanCarlosFOB-bsupply-hc-5', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='SanCarlosFOB-bsupply-hc-6', mission='supply', targetzone='PebbleIsland'}), --
		GroupCommander:new({name='SanCarlosFOB-rsupply-hc-1', mission='supply', targetzone='CapeDolphin'}), --
		GroupCommander:new({name='SanCarlosFOB-rsupply-hc-2', mission='supply', targetzone='LorenzoFARP'}), --
		GroupCommander:new({name='SanCarlosFOB-rsupply-hc-3', mission='supply', targetzone='MountPleasant'}), --
		GroupCommander:new({name='SanCarlosFOB-rsupply-hc-4', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='SanCarlosFOB-rsupply-hc-5', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='SanCarlosFOB-rsupply-hc-6', mission='supply', targetzone='PebbleIsland'}), --
		GroupCommander:new({name='SanCarlosFOB-rattack-hc-1', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='SanCarlosFOB-rattack-hc-2', mission='attack', targetzone='GooseGreen'}),
		GroupCommander:new({name='SanCarlosFOB-rattack-hc-3', mission='attack', targetzone='LorenzoFARP'}),
		GroupCommander:new({name='SanCarlosFOB-rattack-hc-4', mission='attack', targetzone='PortHoward'}),
		GroupCommander:new({name='Red-marines-boat-4', mission='attack', targetzone='PortHoward', type='surface'})
	},
	GooseGreen = {
		GroupCommander:new({name='GooseGreen-bsupply-hc-1', mission='supply', targetzone='MountPleasant'}), --
		GroupCommander:new({name='GooseGreen-bsupply-hc-2', mission='supply', targetzone='BleakerFarm'}), --
		GroupCommander:new({name='GooseGreen-bsupply-hc-3', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='GooseGreen-bsupply-hc-4', mission='supply', targetzone='FoxBayAirfield'}), --
		GroupCommander:new({name='GooseGreen-bsupply-hc-5', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='GooseGreen-bsupply-hc-6', mission='supply', targetzone='SanCarlosFOB'}), --
		GroupCommander:new({name='GooseGreen-rsupply-hc-1', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='GooseGreen-rsupply-hc-2', mission='supply', targetzone='BleakerFarm'}), --
		GroupCommander:new({name='GooseGreen-rsupply-hc-3', mission='supply', targetzone='MountPleasant'}), --
		GroupCommander:new({name='GooseGreen-rsupply-hc-4', mission='supply', targetzone='SanCarlosFOB'}), --
		GroupCommander:new({name='GooseGreen-rsupply-hc-5', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='GooseGreen-rsupply-hc-6', mission='supply', targetzone='FoxBayAirfield'}), --
		GroupCommander:new({name='GooseGreen-rattack-hc-1', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='GooseGreen-rattack-hc-2', mission='attack', targetzone='BleakerFarm'}),
		GroupCommander:new({name='GooseGreen-rattack-hc-3', mission='attack', targetzone='NorthArmFarm'}),
		GroupCommander:new({name='GooseGreen-rattack-hc-4', mission='attack', targetzone='FoxBayAirfield'}),
		GroupCommander:new({name='GooseGreen-rattack-hc-5', mission='attack', targetzone='PortHoward'})
	},
	PebbleIsland = {
		GroupCommander:new({name='PebbleIsland-rattack-hc-1', mission='attack', targetzone='PortHoward'})
	},
	NorthWestPointFARP = {
		GroupCommander:new({name='NorthWestPointFARP-rattack-hc-1', mission='attack', targetzone='PortHoward'})
	},
	PortHoward = {
		GroupCommander:new({name='PortHoward-bsupply-hc-1', mission='supply', targetzone='SanCarlosFOB'}), --
		GroupCommander:new({name='PortHoward-bsupply-hc-3', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='PortHoward-bsupply-hc-4', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='PortHoward-bsupply-hc-5', mission='supply', targetzone='ShallopPoint'}), --
		GroupCommander:new({name='PortHoward-bsupply-hc-6', mission='supply', targetzone='NorthWestPointFARP'}), --
		GroupCommander:new({name='PortHoward-bsupply-hc-7', mission='supply', targetzone='PebbleIsland'}), --
		GroupCommander:new({name='PortHoward-rsupply-hc-1', mission='supply', targetzone='SanCarlosFOB'}),	--
		GroupCommander:new({name='PortHoward-rsupply-hc-3', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='PortHoward-rsupply-hc-4', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='PortHoward-rsupply-hc-5', mission='supply', targetzone='ShallopPoint'}), --
		GroupCommander:new({name='PortHoward-rsupply-hc-6', mission='supply', targetzone='NorthWestPointFARP'}), --
		GroupCommander:new({name='PortHoward-rsupply-hc-7', mission='supply', targetzone='PebbleIsland'}) --
	},
	ShallopPoint = {
		GroupCommander:new({name='ShallopPoint-rattack-hc-1', mission='attack', targetzone='PortHoward'})
	},
	FoxBayAirfield = {
		GroupCommander:new({name='FoxBayAirfield-bsupply-hc-1', mission='supply', targetzone='ShallopPoint'}), --
		GroupCommander:new({name='FoxBayAirfield-bsupply-hc-2', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='FoxBayAirfield-bsupply-hc-3', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='FoxBayAirfield-bsupply-hc-4', mission='supply', targetzone='AlbemarieStation'}), --
		GroupCommander:new({name='FoxBayAirfield-bsupply-hc-5', mission='supply', targetzone='WeddelFarmFARP'}), --
		GroupCommander:new({name='FoxBayAirfield-bsupply-sh-1', mission='supply', targetzone='PortStephens', type='surface'}), --
		GroupCommander:new({name='FoxBayAirfield-rsupply-hc-1', mission='supply', targetzone='ShallopPoint'}), --
		GroupCommander:new({name='FoxBayAirfield-rsupply-hc-2', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='FoxBayAirfield-rsupply-hc-3', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='FoxBayAirfield-rsupply-hc-4', mission='supply', targetzone='AlbemarieStation'}), --
		GroupCommander:new({name='FoxBayAirfield-rsupply-hc-5', mission='supply', targetzone='WeddelFarmFARP'}), --
		GroupCommander:new({name='FoxBayAirfield-rsupply-sh-1', mission='supply', targetzone='PortStephens', type='surface'}), --
		GroupCommander:new({name='FoxBayAirfield-rattack-hc-1', mission='attack', targetzone='PortHoward'}),
		GroupCommander:new({name='FoxBayAirfield-rattack-hc-2', mission='attack', targetzone='GooseGreen'}),
		GroupCommander:new({name='FoxBayAirfield-rattack-hc-3', mission='attack', targetzone='NorthArmFarm'}),
		GroupCommander:new({name='FoxBayAirfield-rattack-hc-4', mission='attack', targetzone='WeddelFarmFARP'})
	},
	NorthArmFarm = {
		GroupCommander:new({name='NorthArmFarm-bsupply-hc-1', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='NorthArmFarm-bsupply-hc-2', mission='supply', targetzone='BleakerFarm'}), --
		GroupCommander:new({name='NorthArmFarm-bsupply-hc-3', mission='supply', targetzone='FoxBayAirfield'}), --
		GroupCommander:new({name='NorthArmFarm-bsupply-hc-4', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='NorthArmFarm-rsupply-hc-1', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='NorthArmFarm-rsupply-hc-2', mission='supply', targetzone='BleakerFarm'}), --
		GroupCommander:new({name='NorthArmFarm-rsupply-hc-3', mission='supply', targetzone='FoxBayAirfield'}), --
		GroupCommander:new({name='NorthArmFarm-rsupply-hc-4', mission='supply', targetzone='PortHoward'}), --
		GroupCommander:new({name='NorthArmFarm-rattack-hc-1', mission='attack', targetzone='GooseGreen'}),
		GroupCommander:new({name='NorthArmFarm-rattack-hc-2', mission='attack', targetzone='BleakerFarm'}),
		GroupCommander:new({name='NorthArmFarm-rattack-hc-3', mission='attack', targetzone='FoxBayAirfield'}),
		GroupCommander:new({name='NorthArmFarm-rattack-hc-4', mission='attack', targetzone='PortHoward'}),
		GroupCommander:new({name='NorthArmFarm-rattack-hc-5', mission='attack', targetzone='SeaLionIsland'})
	},
	BleakerFarm = {
		GroupCommander:new({name='BleakerFarm-bsupply-hc-1', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='BleakerFarm-bsupply-hc-2', mission='supply', targetzone='Carrier'}), --
		GroupCommander:new({name='BleakerFarm-bsupply-hc-3', mission='supply', targetzone='SeaLionIsland'}), --
		GroupCommander:new({name='BleakerFarm-bsupply-hc-4', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='BleakerFarm-rsupply-hc-1', mission='supply', targetzone='GooseGreen'}), --
		GroupCommander:new({name='BleakerFarm-rsupply-hc-2', mission='supply', targetzone='SeaLionIsland'}), --
		GroupCommander:new({name='BleakerFarm-rsupply-hc-3', mission='supply', targetzone='NorthArmFarm'}), --
		GroupCommander:new({name='BleakerFarm-rsupply-1', mission='supply', targetzone='RioGrande'}), --
		GroupCommander:new({name='Red-Marines-Boat-5', mission='attack', targetzone='NorthArmFarm', type='surface'})
	},
-----------------------------------------------------------------------------------------------------------------------
---- Below is the South America Mainland Zone dispatch configurations
-----------------------------------------------------------------------------------------------------------------------	
	RioGrande = {
		GroupCommander:new({name='RioGrande-bsupply-ac-1', mission='supply', targetzone='PuntaArenas'}), --
		GroupCommander:new({name='RioGrande-rsupply-1', mission='supply', targetzone='BleakerFarm'}), --
		GroupCommander:new({name='RioGrande-rsupply-2', mission='supply', targetzone='RioGallegos'}), --
		GroupCommander:new({name='RioGrande-rsupply-3', mission='supply', targetzone='PuntaArenas'}), --
		GroupCommander:new({name='RioGrande-rsupply-4', mission='supply', targetzone='Ushuaia'}),
		GroupCommander:new({name='RioGrande-rsupply-hc-1', mission='supply', targetzone='Castillo'}), --
		GroupCommander:new({name='RioGrande-rsupply-hc-2', mission='supply', targetzone='AerodromoDeTolhuin'}), --
		GroupCommander:new({name='RioGrande-rpatrol-ac-1', mission='patrol', targetzone='RioGrande'}),
		GroupCommander:new({name='RioGrande-rpatrol-sh-1', mission='patrol', targetzone='RioGrande', type='surface'}),
		GroupCommander:new({name='RioGrande-rpatrol-sh-2', mission='patrol', targetzone='Ushuaia', type='surface'}),
		GroupCommander:new({name='RioGrande-rattack-ac-1', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='RioGrande-rattack-ac-2', mission='attack', targetzone='BleakerFarm'}),
		GroupCommander:new({name='RioGrande-rattack-ac-3', mission='attack', targetzone='Carrier'}),
		GroupCommander:new({name='RioGrande-rattack-ac-4', mission='attack', targetzone='Ushuaia'}),
		GroupCommander:new({name='RioGrande-rattack-ac-5', mission='attack', targetzone='PuntaArenas'}),
		GroupCommander:new({name='RioGrande-rattack-ac-5', mission='attack', targetzone='RioGallegos'}),
		GroupCommander:new({name='RioGrande-rattack-hc-1', mission='attack', targetzone='PampaGuanaco'}),
		GroupCommander:new({name='RioGrande-rattack-hc-2', mission='attack', targetzone='AerodromoDeTolhuin'})
	},
	AerodromoDeTolhuin = {
		GroupCommander:new({name='AerodromoDeTolhuin-rsupply-hc-1', mission='supply', targetzone='Ushuaia'}) --
	},
	Ushuaia = {
		GroupCommander:new({name='Ushuaia-bsupply-ac-1', mission='supply', targetzone='PuntaArenas'}), --
		GroupCommander:new({name='Ushuaia-rsupply-hc-1', mission='supply', targetzone='PuertoWilliams'}) --
	},
	PuntaArenas = {
		GroupCommander:new({name='PuntaArenas-bsupply-ac-1', mission='supply', targetzone='PuertoNatales'}), --
		GroupCommander:new({name='PuntaArenas-bsupply-ac-2', mission='supply', targetzone='RioGallegos'}), --
		GroupCommander:new({name='PuntaArenas-bsupply-ac-3', mission='supply', targetzone='AerodromoOHiggins'}), --
		GroupCommander:new({name='PuntaArenas-bsupply-ac-4', mission='supply', targetzone='RioGrande'}), --
		GroupCommander:new({name='PuntaArenas-bsupply-ac-5', mission='supply', targetzone='SanJulian'}), --
		GroupCommander:new({name='PuntaArenas-bsupply-ac-6', mission='supply', targetzone='Ushuaia'}), --
		GroupCommander:new({name='PuntaArenas-rsupply-ac-1', mission='supply', targetzone='RioGallegos'}), --
		GroupCommander:new({name='PuntaArenas-rsupply-ac-2', mission='supply', targetzone='RioGrande'}), --
		GroupCommander:new({name='PuntaArenas-rsupply-ac-3', mission='supply', targetzone='AlmiranteSchroeders'}), --
		GroupCommander:new({name='PuntaArenas-rsupply-ac-4', mission='supply', targetzone='PuertoNatales'}), --
		GroupCommander:new({name='PuntaArenas-rsupply-hc-1', mission='supply', targetzone='PorvenirAirfield'}) --
	},
	PorvenirAirfield = {
		GroupCommander:new({name='PorvenirAirfield-rsupply-hc-1', mission='supply', targetzone='FrancoBianco'}) --
	},
	RioGallegos = {
		GroupCommander:new({name='RioGallegos-bsupply-ac-1', mission='supply', targetzone='PuntaArenas'}), --
		GroupCommander:new({name='RioGallegos-rsupply-1', mission='supply', targetzone='SanJulian'}), --
		GroupCommander:new({name='RioGallegos-rsupply-2', mission='supply', targetzone='RioGrande'}), --
		GroupCommander:new({name='RioGallegos-rsupply-3', mission='supply', targetzone='PuntaArenas'}), --
		GroupCommander:new({name='RioGallegos-rsupply-4', mission='supply', targetzone='RioTurbio'}), --
		GroupCommander:new({name='RioGallegos-rsupply-hc-1', mission='supply', targetzone='RioChico'}), --
		GroupCommander:new({name='RioGallegos-rpatrol-ac-1', mission='patrol', targetzone='RioGallegos'}),
		GroupCommander:new({name='RioGallegos-rattack-ac-1', mission='attack', targetzone='GooseGreen'}),
		GroupCommander:new({name='RioGallegos-rattack-ac-2', mission='attack', targetzone='PortHoward'}),
		GroupCommander:new({name='RioGallegos-rattack-ac-3', mission='attack', targetzone='PuntaArenas'}),
		GroupCommander:new({name='RioGallegos-rattack-ac-4', mission='attack', targetzone='RioGrande'}),
		GroupCommander:new({name='RioGallegos-rattack-ac-5', mission='attack', targetzone='RioTurbio'}),
		GroupCommander:new({name='RioGallegos-rattack-ac-6', mission='attack', targetzone='SanJulian'})
	},
	RioTurbio = {
		GroupCommander:new({name='RioTurbio-rsupply-1', mission='supply', targetzone='ElCalafate'}), --
		GroupCommander:new({name='RioTurbio-rsupply-hc-1', mission='supply', targetzone='PuertoNatales'}), --
		GroupCommander:new({name='RioTurbio-rsupply-hc-2', mission='supply', targetzone='Esperanza'}) --
	},
	ComandanteLuisPiedrabuena = {
		GroupCommander:new({name='ComandanteLuisPiedrabuena-rsupply-hc-1', mission='supply', targetzone='PuertoSantaCruz'}) --
	},
	AeropuertodeGobernadorGregores = {
		GroupCommander:new({name='AeropuertodeGobernadorGregores-rsupply-1', mission='supply', targetzone='ElCalafate'}), --
		GroupCommander:new({name='AeropuertodeGobernadorGregores-rsupply-2', mission='supply', targetzone='AerodromoOHiggins'}), --
		GroupCommander:new({name='AeropuertodeGobernadorGregores-rsupply-3', mission='supply', targetzone='PuertoSantaCruz'}), --
		GroupCommander:new({name='AeropuertodeGobernadorGregores-rsupply-hc-1', mission='supply', targetzone='LagunaGrande'}) --
	},
	SanJulian = {
		GroupCommander:new({name='SanJulian-rsupply-1', mission='supply', targetzone='PortStanley'}), --
		GroupCommander:new({name='SanJulian-rsupply-2', mission='supply', targetzone='RioGallegos'}), --
		GroupCommander:new({name='SanJulian-rsupply-3', mission='supply', targetzone='AeropuertodeGobernadorGregores'}), --
		GroupCommander:new({name='SanJulian-rpatrol-ac-1', mission='patrol', targetzone='SanJulian'}),
		GroupCommander:new({name='SanJulian-rattack-ac-1', mission='attack', targetzone='PortStanley'}),
		GroupCommander:new({name='SanJulian-rattack-ac-2', mission='attack', targetzone='SanCarlosFOB'}),
		GroupCommander:new({name='SanJulian-rattack-ac-3', mission='attack', targetzone='MountPleasant'}),
		GroupCommander:new({name='SanJulian-rattack-ac-4', mission='attack', targetzone='RioGallegos'}),
		GroupCommander:new({name='SanJulian-rattack-ac-5', mission='attack', targetzone='ElCalafate'}),
		GroupCommander:new({name='SanJulian-rattack-ac-6', mission='attack', targetzone='AeropuertodeGobernadorGregores'})
	},
	RedNavalZone = {
		GroupCommander:new({name='RNZ-rpatrol-ac-1', mission='patrol', targetzone='NorthWestPointFARP'}), --
		GroupCommander:new({name='RNZ-rpatrol-ac-2', mission='patrol', targetzone='FoxBayAirfield'}),
		GroupCommander:new({name='RNZ-rpatrol-ac-3', mission='patrol', targetzone='NorthArmFarm'})
	},
	
}

-- Add defined Groups in Mission Editor to your Zones in ZoneCommander
MountPleasant:addGroups(dispatch.MountPleasant)
Carrier:addGroups(dispatch.Carrier)
PortStanley:addGroups(dispatch.PortStanley)
SanCarlosFOB:addGroups(dispatch.SanCarlosFOB)
GooseGreen:addGroups(dispatch.GooseGreen)
PebbleIsland:addGroups(dispatch.PebbleIsland)
NorthWestPointFARP:addGroups(dispatch.NorthWestPointFARP)
PortHoward:addGroups(dispatch.PortHoward)
ShallopPoint:addGroups(dispatch.ShallopPoint)
FoxBayAirfield:addGroups(dispatch.FoxBayAirfield)
BleakerFarm:addGroups(dispatch.BleakerFarm)
RioGrande:addGroups(dispatch.RioGrande)
AerodromoDeTolhuin:addGroups(dispatch.AerodromoDeTolhuin)
Ushuaia:addGroups(dispatch.Ushuaia)
PuntaArenas:addGroups(dispatch.PuntaArenas)
PorvenirAirfield:addGroups(dispatch.PorvenirAirfield)
RioGallegos:addGroups(dispatch.RioGallegos)
RioTurbio:addGroups(dispatch.RioTurbio)
ComandanteLuisPiedrabuena:addGroups(dispatch.ComandanteLuisPiedrabuena)
AeropuertodeGobernadorGregores:addGroups(dispatch.AeropuertodeGobernadorGregores)
SanJulian:addGroups(dispatch.SanJulian)
RedNavalZone:addGroups(dispatch.RedNavalZone)


-- Add defined Zones in Mission Editor to ZoneCommander
bc:addZone(MountPleasant)
bc:addZone(Carrier)
bc:addZone(PortStanley)
bc:addZone(LorenzoFARP)
bc:addZone(CapeDolphin)
bc:addZone(SanCarlosFOB)
bc:addZone(GooseGreen)
bc:addZone(PebbleIsland)
bc:addZone(NorthWestPointFARP)
bc:addZone(PortHoward)
bc:addZone(ShallopPoint)
bc:addZone(FoxBayAirfield)
bc:addZone(WeddelFarmFARP)
bc:addZone(PortStephens)
bc:addZone(AlbemarieStation)
bc:addZone(NorthArmFarm)
bc:addZone(BleakerFarm)
bc:addZone(SeaLionIsland)
bc:addZone(RioGrande)
bc:addZone(Castillo)
bc:addZone(Ushuaia)
bc:addZone(PuertoWilliams)
bc:addZone(AerodromoDeTolhuin)
bc:addZone(PampaGuanaco)
bc:addZone(AlmiranteSchroeders)
bc:addZone(PorvenirAirfield)
bc:addZone(FrancoBianco)
bc:addZone(PuntaArenas)
bc:addZone(RioGallegos)
bc:addZone(RioChico)
bc:addZone(Esperanza)
bc:addZone(RioTurbio)
bc:addZone(PuertoNatales)
bc:addZone(ElCalafate)
bc:addZone(AerodromoOHiggins)
bc:addZone(AeropuertodeGobernadorGregores)
bc:addZone(LagunaGrande)
bc:addZone(PuertoSantaCruz)
bc:addZone(ComandanteLuisPiedrabuena)
bc:addZone(SanJulian)
bc:addZone(RedNavalZone)


-- Add criticalobjects (if any) to your zones to give players a strategic target they can bomb. Destroying these will disable the zone.
LagunaGrande:addCriticalObject('LagunaGrande-CommsTower')
LagunaGrande:addCriticalObject('LagunaGrande-CommandCenter')
LagunaGrande:addCriticalObject('LagunaGrande-AmmoDepot')
Esperanza:addCriticalObject('Esperanza-CommsTower')
Esperanza:addCriticalObject('Esperanza-CommandCenter')
Esperanza:addCriticalObject('Esperanza-AmmoDepot')
Castillo:addCriticalObject('Castillo-CommsTower')
Castillo:addCriticalObject('Castillo-CommandCenter')
Castillo:addCriticalObject('Castillo-AmmoDepot')



-- Add connections between zones to give players an overview of the tactical advancement options and supply routes
bc:addConnection("MountPleasant","PortStanley")
bc:addConnection("MountPleasant","GooseGreen")
bc:addConnection("MountPleasant","SanCarlosFOB")
bc:addConnection("MountPleasant","Carrier")
bc:addConnection("Carrier","PortStanley")
bc:addConnection("Carrier","BleakerFarm")
bc:addConnection("PortStanley","LorenzoFARP")
bc:addConnection("PortStanley","PortHoward")
bc:addConnection("LorenzoFARP","CapeDolphin")
bc:addConnection("SanCarlosFOB","LorenzoFARP")
bc:addConnection("SanCarlosFOB","CapeDolphin")
bc:addConnection("SanCarlosFOB","PebbleIsland")
bc:addConnection("SanCarlosFOB","PortHoward")
bc:addConnection("PortHoward","NorthWestPointFARP")
bc:addConnection("PortHoward","PebbleIsland")
bc:addConnection("PortHoward","ShallopPoint")
bc:addConnection("PortHoward","NorthWestPointFARP")
bc:addConnection("PortHoward","NorthArmFarm")
bc:addConnection("PebbleIsland","NorthWestPointFARP")
bc:addConnection("PebbleIsland","ShallopPoint")
bc:addConnection("GooseGreen","SanCarlosFOB")
bc:addConnection("GooseGreen","PortHoward")
bc:addConnection("GooseGreen","FoxBayAirfield")
bc:addConnection("GooseGreen","NorthArmFarm")
bc:addConnection("GooseGreen","BleakerFarm")
bc:addConnection("NorthArmFarm","BleakerFarm")
bc:addConnection("ShallopPoint","FoxBayAirfield")
bc:addConnection("ShallopPoint","NorthWestPointFARP")
bc:addConnection("ShallopPoint","WeddelFarmFARP")
bc:addConnection("FoxBayAirfield","WeddelFarmFARP")
bc:addConnection("FoxBayAirfield","AlbemarieStation")
bc:addConnection("FoxBayAirfield","NorthArmFarm")
bc:addConnection("PortStephens","WeddelFarmFARP")
bc:addConnection("PortStephens","AlbemarieStation")
bc:addConnection("SeaLionIsland","AlbemarieStation")
bc:addConnection("SeaLionIsland","BleakerFarm")
bc:addConnection("RioGallegos","WeddelFarmFARP")
bc:addConnection("RioGallegos","RioGrande")
bc:addConnection("RioGallegos","RioChico")
bc:addConnection("RioGallegos","RioTurbio")
bc:addConnection("RioGallegos","PuertoSantaCruz")
bc:addConnection("RioGallegos","ElCalafate")
bc:addConnection("PuertoSantaCruz","ComandanteLuisPiedrabuena")
bc:addConnection("PuertoSantaCruz","AeropuertodeGobernadorGregores")
bc:addConnection("RioGrande","BleakerFarm")
bc:addConnection("RioGrande","Ushuaia")
bc:addConnection("RioGrande","AerodromoDeTolhuin")
bc:addConnection("RioGrande","PampaGuanaco")
bc:addConnection("ElCalafate","RioTurbio")
bc:addConnection("ElCalafate","ComandanteLuisPiedrabuena")
bc:addConnection("ElCalafate","AeropuertodeGobernadorGregores")
bc:addConnection("Ushuaia","PuertoWilliams")
bc:addConnection("Ushuaia","AerodromoDeTolhuin")
bc:addConnection("PuertoWilliams","AlmiranteSchroeders")
bc:addConnection("PuertoWilliams","PampaGuanaco")
bc:addConnection("PuntaArenas","RioGallegos")
bc:addConnection("PuntaArenas","RioGrande")
bc:addConnection("PuntaArenas","MountPleasant")
bc:addConnection("PuntaArenas","AlmiranteSchroeders")
bc:addConnection("PuntaArenas","PorvenirAirfield")
bc:addConnection("PuntaArenas","PuertoNatales")
bc:addConnection("RioTurbio","PuertoNatales")
bc:addConnection("PorvenirAirfield","FrancoBianco")
bc:addConnection("PorvenirAirfield","AlmiranteSchroeders")
bc:addConnection("PorvenirAirfield","PampaGuanaco")
bc:addConnection("AerodromoOHiggins","AeropuertodeGobernadorGregores")
bc:addConnection("AerodromoOHiggins","PuertoNatales")
bc:addConnection("SanJulian","PortStanley")
bc:addConnection("SanJulian","RioGallegos")
bc:addConnection("SanJulian","ComandanteLuisPiedrabuena")
bc:addConnection("SanJulian","AeropuertodeGobernadorGregores")


local showCredIncrease = function(event, sender)
	trigger.action.outTextForCoalition(sender.side, '+'..math.floor(sender.income*360)..' Credits/Hour', 5)
end


-------------------------------------------------------------------------------------------------------------------------------------
-- Event triggers using the following format:
-- exampleZone:registerTrigger('eventname', function(event, sender) trigger.action.outText('event triggered',5) end, 'triggerid', 4)
-- bc:fireAtZone(target, 'cruise1', true, 8)
-------------------------------------------------------------------------------------------------------------------------------------
MountPleasant:registerTrigger('captured', showCredIncrease, 'MountPleasant')

AerodromoOHiggins:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean airfield of Aerodromo OHiggins have been invaded!',15) end, 'AerodromoOHiggins-Captures', 1)
PuertoNatales:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean airfield of Puerto Natales have been invaded!',15) end, 'PuertoNatales-Captures', 1)
PuntaArenas:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean airport of Punta Arenas have been invaded!',15) end, 'PuntaArenas-Captures', 1)
FrancoBianco:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean airport Franco Bianco have been invaded!',15) end, 'FrancoBianco-Captures', 1)
PorvenirAirfield:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean Porvenir Airfield have been invaded!',15) end, 'PorvenirAirfield-Captures', 1)
AlmiranteSchroeders:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean airport Almirante Schroeders have been invaded!',15) end, 'AlmiranteSchroeders-Captures', 1)
PampaGuanaco:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean Pampa Guanaco airfield have been invaded!',15) end, 'PampaGuanaco-Captures', 1)
PuertoWilliams:registerTrigger('captured', function(event, sender) trigger.action.outText('The neutral Chilean Puerto Williams airfield have been invaded!',15) end, 'PuertoWilliams-Captures', 1)
-------------------------------------------------------------------------------------------------------------------------------
GooseGreen:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('GooseGreen')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Patrol-Corvette-1', 120)
		trigger.action.outTextForCoalition(2, 'An enemy Corvette-class patrol ship was sighted 50NM south-west of the Falklands.', 15)
		if mist.groupIsDead('Red-Patrol-Corvette-1') == true then
			mist.respawnGroup('Red-Patrol-Corvette-1', 120)
		end
	end
end, 'GooseGreencaptured')
-------------------------------------------------------------------------------------------------------------------------------
AerodromoDeTolhuin:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('AerodromoDeTolhuin')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-1', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted East of AerodromoDeTolhuin.', 15)
		if mist.groupIsDead('Red-LandPatrol-1') == true then
			mist.respawnGroup('Red-LandPatrol-1', 120)
		end
	end
end, 'AerodromoDeTolhuincaptured')
-------------------------------------------------------------------------------------------------------------------------------
PampaGuanaco:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('PampaGuanaco')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-2', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted North of PampaGuanaco.', 15)
		if mist.groupIsDead('Red-LandPatrol-2') == true then
			mist.respawnGroup('Red-LandPatrol-2', 120)
		end
	end
end, 'PampaGuanacocaptured')
-------------------------------------------------------------------------------------------------------------------------------
FrancoBianco:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('FrancoBianco')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-3', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted North of FrancoBianco.', 15)
		if mist.groupIsDead('Red-LandPatrol-3') == true then
			mist.respawnGroup('Red-LandPatrol-3', 120)
		end
	end
end, 'FrancoBiancocaptured')
-------------------------------------------------------------------------------------------------------------------------------
ComandanteLuisPiedrabuena:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('ComandanteLuisPiedrabuena')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-4', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted East of ComandanteLuisPiedrabuena.', 15)
		if mist.groupIsDead('Red-LandPatrol-4') == true then
			mist.respawnGroup('Red-LandPatrol-4', 120)
		end
	end
end, 'ComandanteLuisPiedrabuenacaptured')
-------------------------------------------------------------------------------------------------------------------------------
ElCalafate:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('ElCalafate')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-5', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted East of ElCalafate.', 15)
		if mist.groupIsDead('Red-LandPatrol-5') == true then
			mist.respawnGroup('Red-LandPatrol-5', 120)
		end
	end
end, 'ElCalafatecaptured')
-------------------------------------------------------------------------------------------------------------------------------
AeropuertodeGobernadorGregores:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('AeropuertodeGobernadorGregores')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-6', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted East of AeropuertodeGobernadorGregores.', 15)
		if mist.groupIsDead('Red-LandPatrol-6') == true then
			mist.respawnGroup('Red-LandPatrol-6', 120)
		end
	end
end, 'AeropuertodeGobernadorGregorescaptured')
-------------------------------------------------------------------------------------------------------------------------------
RioGrande:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('RioGrande')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-7', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted North of RioGrande.', 15)
		if mist.groupIsDead('Red-LandPatrol-7') == true then
			mist.respawnGroup('Red-LandPatrol-7', 120)
		end
	end
end, 'RioGrandecaptured')
-------------------------------------------------------------------------------------------------------------------------------
RioGallegos:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('RioGallegos')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-8', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted West of RioGallegos.', 15)
		if mist.groupIsDead('Red-LandPatrol-8') == true then
			mist.respawnGroup('Red-LandPatrol-8', 120)
		end
	end
end, 'RioGallegoscaptured')
-------------------------------------------------------------------------------------------------------------------------------
RioGallegos:registerTrigger('lost', function(event,sender)
	local kr = bc:getZoneByName('RioGallegos')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-9', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted near RioGrande.', 15)
		if mist.groupIsDead('Red-LandPatrol-9') == true then
			mist.respawnGroup('Red-LandPatrol-9', 120)
		end
	end
end, 'RioGallegoslost')
-------------------------------------------------------------------------------------------------------------------------------
RioChico:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('RioChico')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-10', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted West of RioChico.', 15)
		if mist.groupIsDead('Red-LandPatrol-10') == true then
			mist.respawnGroup('Red-LandPatrol-10', 120)
		end
	end
end, 'RioChicocaptured')
-------------------------------------------------------------------------------------------------------------------------------
RioChico:registerTrigger('lost', function(event,sender)
	local kr = bc:getZoneByName('RioChico')
	if kr.side == 2 then 
		mist.respawnGroup('Red-LandPatrol-11', 120)
		trigger.action.outTextForCoalition(2, 'An enemy patrol convoy was sighted West of RioChico.', 15)
		if mist.groupIsDead('Red-LandPatrol-11') == true then
			mist.respawnGroup('Red-LandPatrol-11', 120)
		end
	end
end, 'RioChicolost')
-------------------------------------------------------------------------------------------------------------------------------
AlmiranteSchroeders:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('AlmiranteSchroeders')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Castle-Patrol-Ships-1', 120)
		trigger.action.outTextForCoalition(2, 'Enemy patrol ships has been sighted in Inutil Bay.', 15)
		if mist.groupIsDead('Red-Castle-Patrol-Ships-1') == true then
			mist.respawnGroup('Red-Castle-Patrol-Ships-1', 120)
		end
	end
end, 'AlmiranteSchroederscaptured')

-------------------------------------------------------------------------------------------------------------------------------
-- End of the Trigger section--------------------------------------------------------------------------------------------------
-- Start of original script----------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local checkMissionComplete = function (event, sender)
	local done = true
	for i,v in ipairs(bc:getZones()) do
		if v.side == 1 then
			done = false
			break
		end
	end
	
	if done then
		trigger.action.outText("Enemy has been defeated. \n\nMission Complete.", 120)
	end
end

for i,v in ipairs(bc:getZones()) do
	v:registerTrigger('lost', checkMissionComplete, 'missioncompleted')
end

--bc:addFunds(1,0)
--bc:addFunds(2,0)

-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('Sweep-1'):destroy()
bc:registerShopItem('sweep1', 'Fighter Sweep Falklands', 250, function(sender) 
	local gr = Group.getByName('Sweep-1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep Falklands mission still in progress'
	end
	mist.respawnGroup('Sweep-1', true)
end,
function (sender, params)
	local gr = Group.getByName('Sweep-1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep Falklands mission still in progress'
	end
	mist.respawnGroup('Sweep-1', true)
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('Sweep-2'):destroy()
bc:registerShopItem('sweep2', 'Fighter Sweep North (F-15C)', 250, function(sender) 
	local gr = Group.getByName('Sweep-2')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep North mission still in progress'
	end
	mist.respawnGroup('Sweep-2', true)
end,
function (sender, params)
	local gr = Group.getByName('Sweep-2')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep North mission still in progress'
	end
	mist.respawnGroup('Sweep-2', true)
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('Sweep-3'):destroy()
bc:registerShopItem('sweep3', 'Fighter Sweep South (F-14B)', 250, function(sender) 
	local gr = Group.getByName('Sweep-3')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep South mission still in progress'
	end
	mist.respawnGroup('Sweep-3', true)
end,
function (sender, params)
	local gr = Group.getByName('Sweep-3')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep South mission still in progress'
	end
	mist.respawnGroup('Sweep-3', true)
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('sead-1'):destroy()
local seadTargetMenu = nil
bc:registerShopItem('seadE', 'Mission: SEAD East (Tornados)', 500, function(sender) 
	local gr = Group.getByName('sead-1')
	if Utils.isGroupActive(gr) then 
		return 'SEAD mission East still in progress'
	end
	mist.respawnGroup('sead-1', true)
	
	if seadTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if Group.getByName('sead-1') then
			local err = bc:engageZone(target, 'sead-1')
			if err then
				return err
			end
			
			trigger.action.outTextForCoalition(2, 'Tornados engaging SAMs at '..target, 15)
		else
			trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
		end
		
		seadTargetMenu = nil
	end
	
	seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD East Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Tornados on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('sead-1')
		if Utils.isGroupActive(gr) then 
			return 'SEAD mission East still in progress'
		end
		
		mist.respawnGroup('sead-1', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('sead-1') then
				local err = bc:engageZone(target, 'sead-1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Tornados engaging SAMs at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('sead-2'):destroy()
local seadTargetMenu = nil
bc:registerShopItem('seadW', 'Mission: SEAD West (Tornados)', 500, function(sender) 
	local gr = Group.getByName('sead-2')
	if Utils.isGroupActive(gr) then 
		return 'SEAD mission West still in progress'
	end
	mist.respawnGroup('sead-2', true)
	
	if seadTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if Group.getByName('sead-2') then
			local err = bc:engageZone(target, 'sead-2')
			if err then
				return err
			end
			
			trigger.action.outTextForCoalition(2, 'Tornados engaging SAMs at '..target, 15)
		else
			trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
		end
		
		seadTargetMenu = nil
	end
	
	seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD West Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Tornados on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('sead-2')
		if Utils.isGroupActive(gr) then 
			return 'SEAD mission West still in progress'
		end
		
		mist.respawnGroup('sead-2', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('sead-2') then
				local err = bc:engageZone(target, 'sead-2')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Tornados engaging SAMs at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('antiship1'):destroy()
bc:registerShopItem('antiship', 'Mission: Anti-ship (F/A-18C)', 500, function(sender) 
	local gr = Group.getByName('antiship1')
	if Utils.isGroupActive(gr) then 
		return 'Anti-ship mission still in progress'
	end
	mist.respawnGroup('antiship1', true)
end,
function (sender, params)
	local gr = Group.getByName('antiship1')
	if Utils.isGroupActive(gr) then 
		return 'Anti-ship mission still in progress'
	end
	mist.respawnGroup('antiship', true)
end)
-------------------------------------------------------------------------------------------------------------------------------
local spawnCVN = function(sender) 
	local gr = Group.getByName('CVN-73 George Washington')
	if Utils.isGroupActive(gr) then 
		return 'The US Navy Carrier is still functioning.'
	end
	mist.respawnGroup('CVN-73 George Washington', true)
	trigger.action.outTextForCoalition(2,'A new US Navy Carrier has been deployed!',15)
end
bc:registerShopItem('newCVN', 'Redeploy a new US Navy Carrier', 5000, spawnCVN, spawnCVN)
-------------------------------------------------------------------------------------------------------------------------------
local spawnLHA = function(sender) 
	local gr = Group.getByName('HMS Invincible')
	if Utils.isGroupActive(gr) then 
		return 'The Royal Navy Carrier is still functioning.'
	end
	mist.respawnGroup('HMS Invincible', true)
	trigger.action.outTextForCoalition(2,'A new Royal Navy Carrier has been deployed!',15)
end
bc:registerShopItem('newLHA', 'Redeploy a new Royal Navy Carrier', 5000, spawnLHA, spawnLHA)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('cas-1'):destroy()
local casTargetMenu = nil
bc:registerShopItem('casE', 'Mission: CAS East at zone', 500, function(sender) 
	local gr = Group.getByName('cas-1')
	if Utils.isGroupActive(gr) then 
		return 'Ground attack mission East still in progress'
	end
	
	mist.respawnGroup('cas-1', true)
	
	if casTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if casTargetMenu then
			if Group.getByName('cas-1') then
				local err = bc:engageZone(target, 'cas-1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Harriers engaging groups at '..target, 15)
			else
				trigger.action.outTextForCoalition(2, 'CAS Group East has left the area or has been destroyed', 15)
			end
			
			casTargetMenu = nil
		end
	end
	
	casTargetMenu = bc:showTargetZoneMenu(2, 'Harrier Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Harriers on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('cas-1')
		if Utils.isGroupActive(gr) then 
			return 'Ground attack mission East still in progress'
		end
		
		mist.respawnGroup('cas-1', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('cas-1') then
				local err = bc:engageZone(target, 'cas-1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Harriers engaging groups at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('cas-2'):destroy()
local casTargetMenu = nil
bc:registerShopItem('casW', 'Mission: CAS West at zone', 500, function(sender) 
	local gr = Group.getByName('cas-2')
	if Utils.isGroupActive(gr) then 
		return 'Ground attack mission West still in progress'
	end
	
	mist.respawnGroup('cas-2', true)
	
	if casTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if casTargetMenu then
			if Group.getByName('cas-2') then
				local err = bc:engageZone(target, 'cas-2')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Warthogs engaging groups at '..target, 15)
			else
				trigger.action.outTextForCoalition(2, 'CAS Group West has left the area or has been destroyed', 15)
			end
			
			casTargetMenu = nil
		end
	end
	
	casTargetMenu = bc:showTargetZoneMenu(2, 'Warthog Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Warthogs on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('cas-2')
		if Utils.isGroupActive(gr) then 
			return 'Ground attack mission West still in progress'
		end
		
		mist.respawnGroup('cas-2', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('cas-2') then
				local err = bc:engageZone(target, 'cas-2')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Warthogs engaging groups at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
bc:addMonitoredROE('cruise1')
local cruiseMissileTargetMenu = nil
bc:registerShopItem('cruisemsl', 'Cruise Missile Strike', 500, function(sender)
	if cruiseMissileTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if cruiseMissileTargetMenu then
			local err = bc:fireAtZone(target, 'cruise1', true, 8)
			if err then
				return err
			end
			
			cruiseMissileTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Launching cruise missiles at '..target, 15)
		end
	end
	
	cruiseMissileTargetMenu = bc:showTargetZoneMenu(2, 'Cruise Missile Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Cruise missiles ready. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local err = bc:fireAtZone(params.zone.zone, 'cruise1', true, 8)
		if err then
			return err
		end
		
		trigger.action.outTextForCoalition(2, 'Launching cruise missiles at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
local upgradeMenu = nil
bc:registerShopItem('supplies', 'Friendly Zone resupply', 1000, function(sender)
	if upgradeMenu then
	return 'Choose zone from F10 menu'
	end
	
	local upgradeZone = function(target)
		if upgradeMenu then
			local zn = bc:getZoneByName(target)
			if zn and zn.side==2 then
				zn:upgrade()
			else
				return 'Zone not friendly'
			end
			
			upgradeMenu = nil
		end
	end
	
	upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply', upgradeZone, 2)
	
	trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		params.zone:upgrade()
	else
		return 'Can only target friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})
bc:registerShopItem('jtac', 'Deploy JTAC Drone', 250, function(sender)
	
	if jtacTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local spawnAndOrbit = function(target)
		if jtacTargetMenu then
			local zn = bc:getZoneByName(target)
			drone:deployAtZone(zn)
			drone:showMenu()
			trigger.action.outTextForCoalition(2, 'Predator drone deployed over '..target, 15)
			jtacTargetMenu = nil
		end
	end
	
	jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC', spawnAndOrbit, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		drone:deployAtZone(params.zone)
		drone:showMenu()
		trigger.action.outTextForCoalition(2, 'Predator drone deployed over '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
local smoketargets = function(tz)
	local units = {}
	for i,v in pairs(tz.built) do
		local g = Group.getByName(v)
		for i2,v2 in ipairs(g:getUnits()) do
			table.insert(units, v2)
		end
	end
	
	local tgts = {}
	for i=1,3,1 do
		if #units > 0 then
			local selected = math.random(1,#units)
			table.insert(tgts, units[selected])
			table.remove(units, selected)
		end
	end
	
	for i,v in ipairs(tgts) do
		local pos = v:getPosition().p
		trigger.action.smoke(pos, 1)
	end
end

local smokeTargetMenu = nil
bc:registerShopItem('smoke', 'Smoke markers', 20, function(sender)
	if smokeTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if smokeTargetMenu then
			local tz = bc:getZoneByName(target)
			smoketargets(tz)
			smokeTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..target, 15)
		end
	end
	
	smokeTargetMenu = bc:showTargetZoneMenu(2, 'Smoke marker target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		smoketargets(params.zone)
		trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
local spawnAwacsEast = function(sender) 
	local gr = Group.getByName('awacs1')
	if Utils.isGroupActive(gr) then 
		return 'Darkstar still active on 252.00 MHz AM'
	end
	mist.respawnGroup('awacs1', true)
	trigger.action.outTextForCoalition(2,'Darkstar active on 252.00 MHz AM',15)
end
Group.getByName('awacs1'):destroy()
bc:registerShopItem('awacsE', 'AWACS East', 100, spawnAwacsEast, spawnAwacsEast)
-------------------------------------------------------------------------------------------------------------------------------
local spawnAwacsWest = function(sender) 
	local gr = Group.getByName('awacs2')
	if Utils.isGroupActive(gr) then 
		return 'Overlord still active on 255.00 MHz AM'
	end
	mist.respawnGroup('awacs2', true)
	trigger.action.outTextForCoalition(2,'Overlord active on 255.00 MHz AM',15)
end
Group.getByName('awacs2'):destroy()
bc:registerShopItem('awacsW', 'AWACS West', 100, spawnAwacsWest, spawnAwacsWest)
-------------------------------------------------------------------------------------------------------------------------------
local spawnNavyTanker = function(sender)
	local gr = Group.getByName('NavyTanker-1')
	if Utils.isGroupActive(gr) then 
		return 'Texaco still active on 253.00 MHz AM'
	end
	mist.respawnGroup('Navy-Tanker-1', true)
	trigger.action.outTextForCoalition(2,'Texaco active on 253.00 MHz AM',15)
end
Group.getByName('NavyTanker-1'):destroy()
bc:registerShopItem('NavyTanker', 'Tanker to the South (S-3B)', 100, spawnNavyTanker, spawnNavyTanker)
-------------------------------------------------------------------------------------------------------------------------------
local spawnAirForceTanker = function(sender)
	local gr = Group.getByName('AirForceTanker-1')
	if Utils.isGroupActive(gr) then 
		return 'Shell still active on 254.00 MHz AM'
	end
	mist.respawnGroup('AirForceTanker-1', true)
	trigger.action.outTextForCoalition(2,'Shell active on 254.00 MHz AM',15)
end
Group.getByName('AirForceTanker-1'):destroy()----------------------
bc:registerShopItem('AirForceTanker', 'Tanker to the South (KC-130)', 100, spawnAirForceTanker, spawnAirForceTanker)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('ewAircraft-1'):destroy()
local jamMenu = nil
bc:registerShopItem('jamE', 'Mission: Jam East radars at zone', 500, function(sender)
	local gr = Group.getByName('ewAircraft-1')
	if Utils.isGroupActive(gr) then 
		return 'Jamming mission East still in progress'
	end
	
	mist.respawnGroup('ewAircraft-1', true)
	
	if jamMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local startJam = function(target)
		if jamMenu then
			bc:jamRadarsAtZone('ewAircraft-1', target)
			jamMenu = nil
			trigger.action.outTextForCoalition(2, 'Growler East jamming radars at '..target, 15)
		end
	end
	
	jamMenu = bc:showTargetZoneMenu(2, 'Jamming target', startJam, 1)
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('ewAircraft-1')
		if Utils.isGroupActive(gr) then 
			return 'Jamming mission East still in progress'
		end
		
		mist.respawnGroup('ewAircraft-1', true)
		
		mist.scheduleFunction(function(target)
			local ew = Group.getByName('ewAircraft-1')
			if ew then
				local err = bc:jamRadarsAtZone('ewAircraft-1', target)
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Growler East jamming radars at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
		
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('ewAircraft-2'):destroy()
local jamMenu = nil
bc:registerShopItem('jamW', 'Mission: Jam West radars at zone', 500, function(sender)
	local gr = Group.getByName('ewAircraft-2')
	if Utils.isGroupActive(gr) then 
		return 'Jamming mission West still in progress'
	end
	
	mist.respawnGroup('ewAircraft-2', true)
	
	if jamMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local startJam = function(target)
		if jamMenu then
			bc:jamRadarsAtZone('ewAircraft-2', target)
			jamMenu = nil
			trigger.action.outTextForCoalition(2, 'Growler West jamming radars at '..target, 15)
		end
	end
	
	jamMenu = bc:showTargetZoneMenu(2, 'Jamming target', startJam, 1)
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('ewAircraft-2')
		if Utils.isGroupActive(gr) then 
			return 'Jamming mission West still in progress'
		end
		
		mist.respawnGroup('ewAircraft-2', true)
		
		mist.scheduleFunction(function(target)
			local ew = Group.getByName('ewAircraft-2')
			if ew then
				local err = bc:jamRadarsAtZone('ewAircraft-2', target)
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Growler West jamming radars at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
		
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
tanksMenu = nil
bc:registerShopItem('armor', 'Reinforcement armor (for combined arms)', 100, function(sender)
	
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Reinforcement armor (Choose friendly zone)', deployTanks, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
artyMenu = nil
bc:registerShopItem('artillery', 'Reinforcement artillery (for combined arms)', 100, function(sender)
	
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Reinforcement artillery (Choose friendly zone)', deployArty, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
reconMenu = nil
bc:registerShopItem('recon', 'Reinforcement recon group (for combined arms)', 50, function(sender)
	
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Reinforcement recon group (Choose friendly zone)', deployRecon, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
airdefMenu = nil
bc:registerShopItem('airdef', 'Reinforcement air defence (for combined arms)', 150, function(sender)
	
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Reinforcement air defence (Choose friendly zone)', deployAirDef, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
bc:addShopItem(2, 'sweep1', -1)
bc:addShopItem(2, 'sweep2', -1)
bc:addShopItem(2, 'sweep3', -1)
bc:addShopItem(2, 'antiship', -1)
bc:addShopItem(2, 'seadE', -1)
bc:addShopItem(2, 'seadW', -1)
bc:addShopItem(2, 'casE', -1)
bc:addShopItem(2, 'casW', -1)
bc:addShopItem(2, 'cruisemsl', 12)
bc:addShopItem(2, 'supplies', -1)
bc:addShopItem(2, 'newCVN', -1)
bc:addShopItem(2, 'jtac', -1)
bc:addShopItem(2, 'smoke', -1)
bc:addShopItem(2, 'jamE', -1)
bc:addShopItem(2, 'jamW', -1)
bc:addShopItem(2, 'awacsE', -1)
bc:addShopItem(2, 'awacsW', -1)
bc:addShopItem(2, 'NavyTanker', -1)
bc:addShopItem(2, 'AirForceTanker', -1)
bc:addShopItem(2, 'newCVN', -1)
bc:addShopItem(2, 'newLHA', -1)

bc:addShopItem(2, 'armor', -1)
bc:addShopItem(2, 'artillery', -1)
-- bc:addShopItem(2, 'recon', -1)
bc:addShopItem(2, 'airdef', -1)
-------------------------------------------------------------------------------------------------------------------------------
--red support------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('redcas1'):destroy()
bc:registerShopItem('redcas-1', 'Red Cas1', 1000, function(sender) 
	local gr = Group.getByName('redcas1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcas1', true)
	trigger.action.outTextForCoalition(2,'The enemy has deployed a couple of Su-34 against our ground forces',15)
end)

Group.getByName('redcas2'):destroy()
bc:registerShopItem('redcas-2', 'Red Cas2', 1000, function(sender) 
	local gr = Group.getByName('redcas2')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcas2', true)
	trigger.action.outTextForCoalition(2,'The enemy has deployed a couple of Su-34 against our ground forces',15)
end)


Group.getByName('redcap1'):destroy()
bc:registerShopItem('redcap-1', 'Red Cap1', 1000, function(sender) 
	local gr = Group.getByName('redcap1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcap1', true)
	trigger.action.outTextForCoalition(2,'Enemy MiG-31 interceptors, coming in from the mainland',15)
end)

Group.getByName('redcap2'):destroy()
bc:registerShopItem('redcap-2', 'Red Cap2', 1000, function(sender) 
	local gr = Group.getByName('redcap2')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcap2', true)
	trigger.action.outTextForCoalition(2,'Enemy MiG-31 interceptors, on course for the southern mainland.',15)
end)

Group.getByName('redcap3'):destroy()
bc:registerShopItem('redcap-3', 'Red Cap3', 1000, function(sender) 
	local gr = Group.getByName('redcap3')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcap3', true)
	trigger.action.outTextForCoalition(2,'Enemy MiG-31 interceptors, on course the northern mainland.',15)
end)


Group.getByName('redsead1'):destroy()
bc:registerShopItem('redsead-1', 'Red Sead1', 1000, function(sender) 
	local gr = Group.getByName('redsead1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redsead1', true)
	trigger.action.outTextForCoalition(2,'The enemy has launched an attack from the mainland on our air defenses',15)
end)

Group.getByName('redsead2'):destroy()
bc:registerShopItem('redsead-2', 'Red Sead2', 1000, function(sender) 
	local gr = Group.getByName('redsead2')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redsead2', true)
	trigger.action.outTextForCoalition(2,'The enemy has launched an attack on our mainland air defenses',15)
end)

Group.getByName('redsead3'):destroy()
bc:registerShopItem('redsead-3', 'Red Sead3', 1000, function(sender) 
	local gr = Group.getByName('redsead3')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redsead3', true)
	trigger.action.outTextForCoalition(2,'The enemy has launched an attack on our mainland air defenses',15)
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('redmlrs1'):destroy()
bc:registerShopItem('redmlrs-1', 'spawn Red mlrs1', 1000, function(sender) 
	local zn = bc:getZoneByName('PorvenirAirfield')
	if zn.side == 1 and zn.active then
		local gr = Group.getByName('redmlrs1')
		if gr then
			local full = true
			for i,v in ipairs(gr:getUnits()) do
				for i2,v2 in ipairs(v:getAmmo()) do
					if v2.count < 3 then
						full = false
						break
					end
				end
				
				if not full then 
					break
				end
			end
			
			if full and gr:getSize()==gr:getInitialSize() then
				return 'ammo full'
			end
			
			trigger.action.outTextForCoalition(2,'The enemy has resupplied its artillery near PorvenirAirfield',15)
		end
		
		mist.respawnGroup('redmlrs1')
		bc:removeShopItem(1,'redmlrs1fire')
		bc:addShopItem(1, 'redmlrs1fire', 3)
	else
		return 'zone not red'
	end
end)

bc:registerShopItem('redmlrs1fire', 'fire red mlrs1', 200, function(sender) 
	local gr = Group.getByName('redmlrs1')
	if gr then
		local targetzones = {'PuntaArenas', 'AlmiranteSchroeders', 'PorvenirAirfield', 'FrancoBianco'}
		local viabletargets = {}
		for i,v in ipairs(targetzones) do
			local z = bc:getZoneByName(v)
			
			if z and z.side == 2 then
				table.insert(viabletargets, v)
			end
		end

		if #viabletargets==0 then
			return 'no targets'
		end
		
		local targetzn = viabletargets[math.random(1,#viabletargets)]
		
		local err = bc:fireAtZone(targetzn, 'redmlrs1', true, 3, 6)
		
		if not err then
			trigger.action.outTextForCoalition(2,'Enemy artillery has begun preparations to fire on '..targetzn,15)
		else
			return err
		end
	else
		return 'buy first'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('redmlrs2'):destroy()
bc:registerShopItem('redmlrs-2', 'spawn Red mlrs2', 1000, function(sender) 
	local zn = bc:getZoneByName('PortHoward')
	if zn.side == 1 and zn.active then
		local gr = Group.getByName('redmlrs2')
		if gr then
			local full = true
			for i,v in ipairs(gr:getUnits()) do
				for i2,v2 in ipairs(v:getAmmo()) do
					if v2.count < 3 then
						full = false
						break
					end
				end
				
				if not full then 
					break
				end
			end
			
			if full and gr:getSize()==gr:getInitialSize() then
				return 'ammo full'
			end
			
			trigger.action.outTextForCoalition(2,'The enemy has resupplied its artillery near PortHoward',15)
		end
		
		mist.respawnGroup('redmlrs2')
		bc:removeShopItem(1,'redmlrs2fire')
		bc:addShopItem(1, 'redmlrs2fire', 3)
	else
		return 'zone not red'
	end
end)

bc:registerShopItem('redmlrs2fire', 'fire red mlrs2', 200, function(sender) 
	local gr = Group.getByName('redmlrs2')
	if gr then
		local targetzones = {'MountPleasant', 'GooseGreen', 'SanCarlosFOB', 'PortHoward', 'FoxBayAirfield', 'NorthArmFarm', 'BleakerFarm'}
		local viabletargets = {}
		for i,v in ipairs(targetzones) do
			local z = bc:getZoneByName(v)
			
			if z and z.side == 2 then
				table.insert(viabletargets, v)
			end
		end

		if #viabletargets==0 then
			return 'no targets'
		end
		
		local targetzn = viabletargets[math.random(1,#viabletargets)]
		
		local err = bc:fireAtZone(targetzn, 'redmlrs2', true, 3, 6)
		
		if not err then
			trigger.action.outTextForCoalition(2,'Enemy artillery has begun preparations to fire on '..targetzn,15)
		else
			return err
		end
	else
		return 'buy first'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('redmlrs3'):destroy()
bc:registerShopItem('redmlrs-3', 'spawn Red mlrs3', 1000, function(sender) 
	local zn = bc:getZoneByName('SanJulian')
	if zn.side == 1 and zn.active then
		local gr = Group.getByName('redmlrs3')
		if gr then
			local full = true
			for i,v in ipairs(gr:getUnits()) do
				for i2,v2 in ipairs(v:getAmmo()) do
					if v2.count < 3 then
						full = false
						break
					end
				end
				
				if not full then 
					break
				end
			end
			
			if full and gr:getSize()==gr:getInitialSize() then
				return 'ammo full'
			end
			
			trigger.action.outTextForCoalition(2,'The enemy has resupplied its artillery near SanJulian',15)
		end
		
		mist.respawnGroup('redmlrs3')
		bc:removeShopItem(1,'redmlrs3fire')
		bc:addShopItem(1, 'redmlrs3fire', 3)
	else
		return 'zone not red'
	end
end)

bc:registerShopItem('redmlrs3fire', 'fire red mlrs3', 200, function(sender) 
	local gr = Group.getByName('redmlrs3')
	if gr then
		local targetzones = {'SanJulian', 'PuertoSantaCruz', 'ComandanteLuisPiedrabuena'}
		local viabletargets = {}
		for i,v in ipairs(targetzones) do
			local z = bc:getZoneByName(v)
			
			if z and z.side == 2 then
				table.insert(viabletargets, v)
			end
		end

		if #viabletargets==0 then
			return 'no targets'
		end
		
		local targetzn = viabletargets[math.random(1,#viabletargets)]
		
		local err = bc:fireAtZone(targetzn, 'redmlrs3', true, 3, 6)
		
		if not err then
			trigger.action.outTextForCoalition(2,'Enemy artillery has begun preparations to fire on '..targetzn,15)
		else
			return err
		end
	else
		return 'buy first'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('intercept1'):destroy()
Group.getByName('intercept2'):destroy()
local cargoDieEvent = nil
bc:registerShopItem('intercept1', 'Red intercept', 1000, function(sender) 
	local grt = Group.getByName('intercept1')
	local gre = Group.getByName('intercept2')
	if gre and gre:getSize()>0 and gre:getController():hasTask() then 
		return 'still alive'
	end
	
	if grt and grt:getSize()>0 and grt:getController():hasTask() then 
		return 'still alive'
	end
	
	mist.respawnGroup('intercept1', true)
	mist.respawnGroup('intercept2', true)
	
	if not cargoDieEvent then
		local cargoPlaneDied = function(event)
			if event.id==28 then
				if event.initiator and event.initiator:getCoalition()==2 and event.target and event.target.getName then
					if event.target:getName()=='intercept1' then
						trigger.action.outTextForCoalition(2,'Enemy cargo transport destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
					elseif not Unit.getByName('intercept1') then
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
					end
				end
			end
		end
		
		cargoDieEvent = mist.addEventHandler(cargoPlaneDied)
	end
end)

Group.getByName('escort1'):destroy()
Group.getByName('antiescort1'):destroy()
Group.getByName('antiescort2'):destroy()
bc:registerShopItem('escort1', 'Red antiescort', 1000, function(sender) 
	local gr = Group.getByName('escort1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	
	mist.respawnGroup('escort1', true)
	
	local spawnIntercept = function(groupname)
		if Group.getByName('escort1') then
			local g = Group.getByName(groupname)
			if not g then
				if math.random(1,100) > 30 then
					if math.random(1,100) > 50 then
						trigger.action.outTextForCoalition(2,'Enemy interceptor spotted heading for our cargo transport.',15)
					else
						trigger.action.outTextForCoalition(2,'The enemy has launched an intercept mission against our cargo transport',15)
					end
					mist.respawnGroup(groupname, true)
				end
			end
		end
	end
	
	local timers = {math.random(3*60,15*60), math.random(8*60,15*60)}
	mist.scheduleFunction(spawnIntercept, {'antiescort1'}, timer.getTime()+timers[1])
	mist.scheduleFunction(spawnIntercept, {'antiescort2'}, timer.getTime()+timers[2])
end)


bc:addShopItem(1, 'redcas-1', -1)
bc:addShopItem(1, 'redcas-2', -1)
bc:addShopItem(1, 'redcap-1', -1)
bc:addShopItem(1, 'redcap-2', -1)
bc:addShopItem(1, 'redcap-3', -1)
bc:addShopItem(1, 'redsead-1', -1)
bc:addShopItem(1, 'redsead-2', -1)
bc:addShopItem(1, 'redsead-3', -1)
bc:addShopItem(1, 'redmlrs-1', -1)
bc:addShopItem(1, 'redmlrs-2', -1)
bc:addShopItem(1, 'redmlrs-3', -1)
bc:addShopItem(1, 'intercept1', -1)
bc:addShopItem(1, 'escort1', -1)

budgetAI = BudgetCommander:new({ battleCommander = bc, side=1, decissionFrequency=10*60, decissionVariance=5*60, skipChance = 5})
budgetAI:init()
--end red support

lc = LogisticCommander:new({battleCommander = bc, supplyZones = {'MountPleasant', 'Carrier', 'PortStanley', 'SanCarlosFOB', 'GooseGreen', 'PortHoward', 'FoxBayAirfield', 'BleakerFarm', 'RioGrande', 'Ushuaia', 'PuntaArenas', 'RioGallegos', 'AeropuertodeGobernadorGregores', 'SanJulian'}})
lc:init()


bc:loadFromDisk() --will load and overwrite default zone levels, sides, funds and available shop items
bc:init()
bc:startRewardPlayerContribution(15,{infantry = 5, ground = 15, sam = 30, airplane = 30, ship = 200, helicopter=40, crate=100, rescue = 50})

HercCargoDropSupply.init(bc)

mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})

mc:trackMission({
	title = "Escort",
	description = "Friendly cargo transport has entered the airspace from the south. Protect it from the enemy.",
	messageStart = "New mission: Escort",
	messageEnd = "Mission ended: Escort",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('escort1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Intercept",
	description = "Enemy cargo transport has entered the airspace from the south. Intercept and destroy it before it escapes.",
	messageStart = "New mission: Intercept",
	messageEnd = "Mission ended: Intercept",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('intercept1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Destroy artillery",
	description = "The enemy has deployed artillery near OlfOrote. Destroy it before it has a chance to fire",
	messageStart = "New mission: Destroy artillery",
	messageEnd = "Mission ended: Destroy artillery",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('redmlrs1') then return true end
		
		return false
	end
})



resupplyTarget = nil
mc:trackMission({
	title = function() return "Resupply "..resupplyTarget end,
	description = function() return "Deliver supplies to "..resupplyTarget end,
	messageStart = function() return "New mission: Resupply "..resupplyTarget end,
	messageEnd = function() return "Mission ended: Resupply "..resupplyTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		resupplyTarget = nil
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not resupplyTarget then return false end
		
		local targetzn = bc:getZoneByName(resupplyTarget)
		return targetzn:canRecieveSupply()
	end
})

attackTarget = nil
mc:trackMission({
	title = function() return "Attack "..attackTarget end,
	description = function() return "Destroy enemy forces at "..attackTarget end,
	messageStart = function() return "New mission: Attack "..attackTarget end,
	messageEnd = function() return "Mission ended: Attack "..attackTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		attackTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not attackTarget then return false end
		
		local targetzn = bc:getZoneByName(attackTarget)
		return targetzn.side == 1
	end
})

captureTarget = nil
mc:trackMission({
	title = function() return "Capture "..captureTarget end,
	description = function() return captureTarget.." is neutral. Capture it by delivering supplies" end,
	messageStart = function() return "New mission: Capture "..captureTarget end,
	messageEnd = function() return "Mission ended: Capture "..captureTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		captureTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not captureTarget then return false end
		
		local targetzn = bc:getZoneByName(captureTarget)
		return targetzn.side == 0 and targetzn.active
	end
})

function generateCaptureMission()
	if captureTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 0 and v.active then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		captureTarget = validzones[choice]
		return true
	end
end

function generateAttackMission()
	if attackTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.connections) do
		local to = bc:getZoneByName(v.to)
		local from = bc:getZoneByName(v.from)
		
		if from.side ~= to.side and from.side ~= 0  and to.side ~= 0 and from.active and to.active then
			if from.side == 1 then
				table.insert(validzones, from.zone)
			elseif to.side == 1 then
				table.insert(validzones, to.zone)
			end
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		attackTarget = validzones[choice]
		return true
	end
end

function generateSupplyMission()
	if resupplyTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 2 and v:canRecieveSupply() then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		resupplyTarget = validzones[choice]
		return true
	end
end

timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 40)

timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)

mc:init()

function respawnStatics()
	for i,v in pairs(cargoSpawns) do
		local farp = bc:getZoneByName(i)
		if farp then
			if farp.side==2 then
				for ix,vx in ipairs(v) do
					if not StaticObject.getByName(vx) then
						mist.respawnGroup(vx)
					end
				end
			else
				for ix,vx in ipairs(v) do
					local cr = StaticObject.getByName(vx)
					if cr then
						cr:destroy()
					end
				end
			end
		end
	end
	
	for i,v in pairs(farpSupply) do
		local farp = bc:getZoneByName(i)
		if farp then
			if farp.side==2 then
				for ix,vx in ipairs(v) do
					local gr = Group.getByName(vx)
					if not gr then
						mist.respawnGroup(vx)
					elseif gr:getSize() < gr:getInitialSize() then
						mist.respawnGroup(vx)
					end
				end
			else
				for ix,vx in ipairs(v) do
					local cr = Group.getByName(vx)
					if cr then
						cr:destroy()
					end
				end
			end
		end
	end
end

mist.scheduleFunction(respawnStatics, {}, timer.getTime() + 1, 30)

--- Function to check for player death and subtract a specific amount from the coalition 'bank'

local ev = {} 
ev.bc = bc
function ev:onEvent(event)
    if event.id ~= world.event.S_EVENT_UNIT_LOST then return end 
    if not event.initiator then return end 
    if not event.initiator.getPlayerName then return end 
    if not event.initiator:getPlayerName() then return end 
    
    trigger.action.outText("Player aircraft lost, 200 credits subtracted from coalition ", 10)
--	 trigger.action.outText("Player aircraft lost, 100 credits subtracted from coalition "..event.initiator:getCoalition(), 10) -- Version with coalition number included	
    self.bc:addFunds(event.initiator:getCoalition(),-200) 
end

world.addEventHandler(ev)
